diff -urN punbb-1.3/lang/English/login.php punbb-1.3.4/lang/English/login.php
--- punbb-1.3/lang/English/login.php	2008-10-27 14:45:19.000000000 +0000
+++ punbb-1.3.4/lang/English/login.php	2008-12-08 08:12:44.000000000 +0000
@@ -1,6 +1,6 @@
 <?php
 
-// Language definitions used in delete.php
+// Language definitions used in login.php
 $lang_login = array(
 
 // Miscellaneous
@@ -13,8 +13,8 @@
 'E-mail address help'				=>	'Enter the e-mail address set in your profile.',
 'Login errors'						=>	'<strong>Warning!</strong> The following errors must be corrected before you can login:',
 'Wrong user/pass'					=>	'Incorrect username and/or password.',
-'Login redirect'					=>	'Logged in successfully. Redirecting …',
-'Logout redirect'					=>	'Logged out. Redirecting …',
+'Login redirect'					=>	'Logged in successfully. Redirecting…',
+'Logout redirect'					=>	'Logged out. Redirecting…',
 'No e-mail match'					=>	'There is no user registered with the e-mail address %s.',
 'Invalid e-mail'					=>	'The e-mail address you entered is invalid.',
 'Login options'						=>	'Do you need to %1$s or obtain a %2$s before you login?',
@@ -25,7 +25,7 @@
 'New password request'				=>	'New password request',
 'New password errors'				=>	'<strong>Warning!</strong> The following errors must be corrected before a new password can be sent:',
 'New password info'					=>	'<strong>Important!</strong> An e-mail will be sent to the specified address with instructions on how to change your password.',
-'New password cancel redirect'		=>	'New password request cancelled. Redirecting …',
+'New password cancel redirect'		=>	'New password request cancelled. Redirecting…',
 'Forget mail'						=>	'An e-mail has been sent to the specified address with instructions on how to change your password. If it does not arrive you can contact the forum administrator at %s.',
 'Persistent login'					=>	'Log me in automatically each time I visit.'
 
diff -urN punbb-1.3/lang/English/profile.php punbb-1.3.4/lang/English/profile.php
--- punbb-1.3/lang/English/profile.php	2008-10-30 21:03:47.000000000 +0000
+++ punbb-1.3.4/lang/English/profile.php	2009-04-09 09:06:21.000000000 +0000
@@ -3,22 +3,21 @@
 $lang_profile = array(
 
 // Navigation and sections
-'Profile redirect'			=>	'Profile updated. Redirecting …',
+'Profile redirect'			=>	'Profile updated. Redirecting…',
 'Instructions'				=>	'You will be redirected back to this page',
 'Update profile'			=>	'Update profile',
-'Subform heading'			=>	'%1$s : %2$s',
 
 // Administration stuff
-'User delete redirect'		=>	'User deleted. Redirecting …',
+'User delete redirect'		=>	'User deleted. Redirecting…',
 'Section admin'				=>	'Administration',
 'Delete user'				=>	'Delete user',
 'Delete warning'			=>	'<strong>Warning!</strong> Once deleted a user and/or their posts cannot be restored.',
 'Delete posts info'			=>	'<strong>Warning!</strong> If you choose not to delete this user\'s posts they can only be deleted manually at a later time.',
 'Delete posts'				=>	'Delete posts',
 'Delete posts label'		=>	'Delete any posts and topics %s has made.',
-'Group membership redirect'	=>	'Group membership updated. Redirecting …',
-'Moderate forums redirect'	=>	'Forum moderator rights updated. Redirecting …',
-'Ban redirect'				=>	'Redirecting …',
+'Group membership redirect'	=>	'Group membership updated. Redirecting…',
+'Moderate forums redirect'	=>	'Forum moderator rights updated. Redirecting…',
+'Ban redirect'				=>	'Redirecting…',
 'Ban user'					=>	'Ban user',
 'Ban user info'				=>	'Ban this user via the administration console.',
 'Delete user info'			=>	'Permanently delete this user and, optionally, all their posts.',
@@ -33,7 +32,7 @@
 // Avatar stuff
 'Avatar welcome'			=>	'Set an avatar image to enhance your forum identity',
 'Avatar welcome user'		=>	'Set an avatar image to enhance  %s\'s forum identity',
-'Avatar deleted redirect'	=>	'Avatar deleted. Redirecting …',
+'Avatar deleted redirect'	=>	'Avatar deleted. Redirecting…',
 'Avatars disabled'			=>	'The administrator has disabled avatar support.',
 'No file'					=>	'You did not select a file for upload.',
 'Too large ini'				=>	'The selected file was too large to upload. The server didn\'t allow the upload.',
@@ -45,13 +44,13 @@
 'Too wide or high'			=>	'The file you tried to upload is wider and/or higher than the maximum allowed %sx%s pixels.',
 'Unknown failure'			=>	'An unknown error occurred. Please try again.',
 'Avatar'					=>	'Avatar',
-'Current avatar'			=>	'Current Avatar',
+'Current avatar'			=>	'Current avatar',
 'No avatar info'			=>	'No avatar is currently uploaded.',
 'Avatar info replace'		=>	'Uploading a new avatar will replace your existing avatar.',
 'Avatar info none'			=>	'To display an avatar you first need to upload one.',
 'Avatar info type'			=>	'The allowed image file types are gif, jpeg and png.',
 'Avatar info size'			=>	'The maximum image size allowed is %sx%s pixels and %s bytes (%s KB).',
-'Delete avatar info'		=>	'Delete avatar to cease displaying any avatar.',
+'Delete avatar info'		=>	'Delete avatar to stop displaying any avatar.',
 'Upload avatar file'		=>	'Upload avatar file',
 'Avatar upload help'		=>	'Select file then update your profile to install.',
 'No upload warn'			=>	'<strong>IMPORTANT! </strong> You must choose a file to upload before updating your profile.',
@@ -170,7 +169,7 @@
 'Change pass errors'		=>	'<strong>Warning!</strong> The following errors must be corrected before your password can be updated:',
 'Pass logout'				=>	'A user is currently logged in. Please logout and try again.',
 'Pass key bad'				=>	'The specified password activation key was incorrect or has expired. Please re-request a new password. If that fails, contact the forum administrator at %s.',
-'Pass updated'				=>	'Password updated. Login with your new password. Redirecting …',
+'Pass updated'				=>	'Password updated. Login with your new password. Redirecting…',
 'Change your password'		=>	'Change your password',
 'Change user password'		=>	'Change %s\'s password',
 'Old password'				=>	'Old password',
@@ -178,12 +177,13 @@
 'New password'				=>	'New password',
 'Confirm new password'		=>	'Confirm new password',
 'Wrong old password'		=>	'The old password you entered was incorrect.',
-'Pass updated redirect'		=>	'Password updated. Redirecting …',
+'Pass updated redirect'		=>	'Password updated. Redirecting…',
 
 // Change E-mail stuff
 'Change e-mail errors'		=>	'<strong>Warning!</strong> The following errors must be corrected before your e-mail address can be updated:',
 'E-mail key bad'			=>	'The specified e-mail activation key was incorrect or has expired. Please re-request change of e-mail address. If that fails, contact the forum administrator at %s.',
 'E-mail updated'			=>	'Your e-mail address has been updated.',
+'E-mail updated redirect'	=>	'Your e-mail address has been updated. Redirecting…',
 'Wrong password'			=>	'The password you entered was incorrect.',
 'Activate e-mail sent'		=>	'An email has been sent to the specified address with instructions on how to activate the new e-mail address. If it doesn\'t arrive you can contact the forum administrator at %s.',
 'Change your e-mail'		=>	'Change your e-mail address',
@@ -202,7 +202,7 @@
 
 // Registration stuff (some of these also used by profile)
 'No new regs'				=>	'This forum is not accepting new registrations.',
-'Reg cancel redirect'		=>	'Registration cancelled. Redirecting …',
+'Reg cancel redirect'		=>	'Registration cancelled. Redirecting…',
 'Agreement'					=>	'Agreement',
 'Agreement label'			=>	'I agree to the rules set out above and wish to register.',
 'Agree'						=>	'Agree',
@@ -213,7 +213,7 @@
 'Banned e-mail'				=>	'The e-mail address you entered is banned in this forum. Please choose another e-mail address.',
 'Dupe e-mail'				=>	'Someone else is already registered with that e-mail address. Please choose another e-mail address.',
 'Reg e-mail'				=>	'Thank you for registering. An email has been sent to the specified address with instructions on how to activate your new account. If it doesn\'t arrive you can contact the forum administrator at %s.',
-'Reg complete'				=>	'Registration complete. Logging in and redirecting …',
+'Reg complete'				=>	'Registration complete. Logging in and redirecting…',
 'Register errors'			=>	'<strong>Warning!</strong> The following errors must be corrected before you can register:',
 'E-mail info'				=>	'<strong>Important!</strong> An e-mail will be sent to your new address with an activation link. You must click the link in the e-mail you receive to activate the new address. You must therefore ensure that you enter a valid and current e-mail address.',
 'Reg e-mail info'			=>	'<strong>Important!</strong> An e-mail with an activation link will be sent to the address you provide. You must click the link in the e-mail in order to activate your new account. You must therefore ensure that you enter a valid and current e-mail address.',
diff -urN punbb-1.3/lang/English/search.php punbb-1.3.4/lang/English/search.php
--- punbb-1.3/lang/English/search.php	2008-10-27 14:45:19.000000000 +0000
+++ punbb-1.3.4/lang/English/search.php	2009-04-16 11:01:09.000000000 +0000
@@ -32,6 +32,10 @@
 'Show as posts'				=>	'As posts',
 'Submit search'				=>	'Submit search',
 'User defined search'		=>	'User defined search',
+'Search in'					=>	'Search in',
+'Message and subject'		=>	'Message text and topic subject',
+'Message only'				=>	'Message text only',
+'Topic only'				=>	'Topic subject only',
 
 // Results
 'Search results'			=>	'Search results',
@@ -47,7 +51,7 @@
 'Posts by user'				=>	'Posts by this user',
 'Perform new search'		=>	'Perform new search',
 'Search options'			=>	'Search options',
-'Location'					=>	'Forum: %s',
+'Posted in'					=>	'Posted in ',
 'No terms'					=>	'You have to enter at least one keyword and/or an author to search for.',
 'No hits'					=>	'Your search returned no hits.',
 'No user posts'				=>	'There are no posts by this user in this forum.',
diff -urN punbb-1.3/lang/English/topic.php punbb-1.3.4/lang/English/topic.php
--- punbb-1.3/lang/English/topic.php	2008-10-25 15:27:40.000000000 +0000
+++ punbb-1.3.4/lang/English/topic.php	2009-04-03 10:13:23.000000000 +0000
@@ -8,13 +8,14 @@
 'Search replies'		=>	'(%s replies, posted in %s)',
 'Post reply'			=>	'Post reply',
 'Topic closed'			=>	'[ Closed ]',
+'Topic closed info'		=>	'This topic is closed',
 'No permission'			=>	'Sorry! no permission to post a reply',
 'Topic title'			=>	'Topic: %s',
 'Reply title'			=>	'Re: %s',
 'Login to post'			=>	'You must %1$s or %2$s to post a reply',
-'From'					=>	'From:',				// User location
+'From'					=>	'From:', // User location
 'Registered'			=>	'Registered:',
-'Note'					=>	'Note:',				// Admin note
+'Note'					=>	'Note:', // Admin note
 'IP'					=>	'IP:',
 'Posts'					=>	'Posts',
 'Posts info'			=>	'Posts:',
@@ -32,7 +33,7 @@
 'Unsubscribe'			=>	'Unsubscribe',
 'Subscribe'				=>	'Subscribe',
 'Subscribe info'		=>	'Receive email notification of new posts.',
-'RSS topic feed'		=>	'RSS Topic Feed',
+'RSS topic feed'		=>	'RSS topic feed',
 'Quick post'			=>	'Quick reply to this topic',
 'Post'					=>	'Post',
 'Permalink post'		=>	'Permanent link to this post',
@@ -40,10 +41,10 @@
 'Go to profile'			=>	'Go to %s\'s profile',
 'Move'					=>	'Move topic',
 'Topic options'			=>	'Topic options',
-'Open'					=>  'Open topic',
-'Close'					=>  'Close topic',
-'Unstick'				=>  'Unstick topic',
-'Stick'					=>  'Stick topic',
+'Open'					=>	'Open topic',
+'Close'					=>	'Close topic',
+'Unstick'				=>	'Unstick topic',
+'Stick'					=>	'Stick topic',
 'Moderate topic'		=>	'Moderate topic',
 'Required warn'			=>	'You cannot submit or preview an empty message.',
 
diff -urN punbb-1.3/lang/English/url_replace.php punbb-1.3.4/lang/English/url_replace.php
--- punbb-1.3/lang/English/url_replace.php	2008-10-23 07:49:10.000000000 +0000
+++ punbb-1.3.4/lang/English/url_replace.php	2009-02-03 07:59:05.000000000 +0000
@@ -563,6 +563,13 @@
 'Ь' => '',
 'ь' => '',
 
+'Є' => 'YE',
+'є' => 'YE',
+'Ї' => 'YI',
+'ї' => 'YI',
+'Ґ' => 'KG',
+'ґ' => 'KG',
+
 'ð' => 'd',
 'Ð' => 'D',
 'þ' => 'th',
diff -urN punbb-1.3/lang/English/userlist.php punbb-1.3.4/lang/English/userlist.php
--- punbb-1.3/lang/English/userlist.php	2008-10-27 14:45:19.000000000 +0000
+++ punbb-1.3.4/lang/English/userlist.php	2009-03-18 14:30:52.000000000 +0000
@@ -23,12 +23,8 @@
 'All users'				=>	'All users',
 'Perform new search'	=>	'Perform new user search',
 'Table summary'			=>	'List of users filtered and sorted according to the criteria (if any) you have chosen.',
-'User list options'		=>	'User list options',
-'Perform new search'	=>	'Perform new user search',
 'Submit user search'	=>	'Submit user criteria',
 'Title'					=>	'Title',
-'Posts'					=>	'Posts',
-'User list options'		=>	'User list options'
-
+'Posts'					=>	'Posts'
 
 );
\ No newline at end of file
diff -urN punbb-1.3/login.php punbb-1.3.4/login.php
--- punbb-1.3/login.php	2008-11-08 17:53:23.000000000 +0000
+++ punbb-1.3.4/login.php	2009-04-17 12:51:23.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * Handles logins, logouts, and password reset requests.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -427,7 +427,7 @@
 				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
 					<div class="sf-box text required">
 						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_login['Password'] ?> <em><?php echo $lang_common['Required'] ?></em></span></label><br />
-						<span class="fld-input"><input type="password" id="fld<?php echo $forum_page['fld_count'] ?>" name="req_password" value="<?php echo isset($_POST['req_password']) ? ($_POST['req_password']) : '' ?>" size="35" /></span>
+						<span class="fld-input"><input type="password" id="fld<?php echo $forum_page['fld_count'] ?>" name="req_password" value="<?php echo isset($_POST['req_password']) ? forum_htmlencode($_POST['req_password']) : '' ?>" size="35" /></span>
 					</div>
 				</div>
 <?php ($hook = get_hook('li_login_pre_remember_me_checkbox')) ? eval($hook) : null; ?>
diff -urN punbb-1.3/misc.php punbb-1.3.4/misc.php
--- punbb-1.3/misc.php	2008-11-09 13:28:04.000000000 +0000
+++ punbb-1.3.4/misc.php	2009-04-17 12:51:23.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * Provides various features for forum users (ie: display rules, send emails through the forum, mark a forum as read, etc).
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -33,7 +33,7 @@
 	// Setup breadcrumbs
 	$forum_page['crumbs'] = array(
 		array($forum_config['o_board_title'], forum_link($forum_url['index'])),
-		$lang_common['Rules']
+		array($lang_common['Rules'], forum_link($forum_url['rules']))
 	);
 
 	($hook = get_hook('mi_rules_pre_header_load')) ? eval($hook) : null;
@@ -106,13 +106,13 @@
 	if ($forum_user['is_guest'])
 		message($lang_common['No permission']);
 
-	$fid = intval($_GET['fid']);
+	$fid = isset($_GET['fid']) ? intval($_GET['fid']) : 0;
 	if ($fid < 1)
 		message($lang_common['Bad request']);
 
 	// We validate the CSRF token. If it's set in POST and we're at this point, the token is valid.
 	// If it's in GET, we need to make sure it's valid.
-	if (!isset($_POST['csrf_token']) && (!isset($_GET['csrf_token']) || $_GET['csrf_token'] !== generate_form_token('markforumread'.intval($_GET['fid']).$forum_user['id'])))
+	if (!isset($_POST['csrf_token']) && (!isset($_GET['csrf_token']) || $_GET['csrf_token'] !== generate_form_token('markforumread'.$fid.$forum_user['id'])))
 		csrf_confirm_form();
 
 	($hook = get_hook('mi_markforumread_selected')) ? eval($hook) : null;
@@ -528,7 +528,7 @@
 
 	// We validate the CSRF token. If it's set in POST and we're at this point, the token is valid.
 	// If it's in GET, we need to make sure it's valid.
-	if (!isset($_POST['csrf_token']) && (!isset($_GET['csrf_token']) || $_GET['csrf_token'] !== generate_form_token('subscribe'.intval($_GET['subscribe']).$forum_user['id'])))
+	if (!isset($_POST['csrf_token']) && (!isset($_GET['csrf_token']) || $_GET['csrf_token'] !== generate_form_token('subscribe'.$topic_id.$forum_user['id'])))
 		csrf_confirm_form();
 
 	($hook = get_hook('mi_subscribe_selected')) ? eval($hook) : null;
@@ -590,7 +590,7 @@
 
 	// We validate the CSRF token. If it's set in POST and we're at this point, the token is valid.
 	// If it's in GET, we need to make sure it's valid.
-	if (!isset($_POST['csrf_token']) && (!isset($_GET['csrf_token']) || $_GET['csrf_token'] !== generate_form_token('unsubscribe'.intval($_GET['unsubscribe']).$forum_user['id'])))
+	if (!isset($_POST['csrf_token']) && (!isset($_GET['csrf_token']) || $_GET['csrf_token'] !== generate_form_token('unsubscribe'.$topic_id.$forum_user['id'])))
 		csrf_confirm_form();
 
 	($hook = get_hook('mi_unsubscribe_selected')) ? eval($hook) : null;
diff -urN punbb-1.3/moderate.php punbb-1.3.4/moderate.php
--- punbb-1.3/moderate.php	2008-11-08 13:00:21.000000000 +0000
+++ punbb-1.3.4/moderate.php	2009-04-17 12:51:23.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * Provides various mass-moderation tools to moderators.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -373,7 +373,7 @@
 <?php ($hook = get_hook('mr_confirm_split_posts_pre_subject')) ? eval($hook) : null; ?>
 					<div class="sf-box text required">
 						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_misc['New subject'] ?> <em><?php echo $lang_common['Required'] ?></em></span></label><br />
-						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="new_subject" value="" size="80" maxlength="70" /></span>
+						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="new_subject" value="" size="70" maxlength="70" /></span>
 					</div>
 <?php ($hook = get_hook('mr_confirm_split_posts_pre_confirm_checkbox')) ? eval($hook) : null; ?>
 					<div class="sf-box checkbox">
@@ -416,7 +416,7 @@
 
 	// Determine the post offset (based on $_GET['p'])
 	$forum_page['num_pages'] = ceil(($cur_topic['num_replies'] + 1) / $forum_user['disp_posts']);
-	$forum_page['page'] = (!isset($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $forum_page['num_pages']) ? 1 : intval($_GET['p']);
+	$forum_page['page'] = (!isset($_GET['p']) || !is_numeric($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $forum_page['num_pages']) ? 1 : intval($_GET['p']);
 	$forum_page['start_from'] = $forum_user['disp_posts'] * ($forum_page['page'] - 1);
 	$forum_page['finish_at'] = min(($forum_page['start_from'] + $forum_user['disp_posts']), ($cur_topic['num_replies'] + 1));
 	$forum_page['items_info'] = generate_items_info($lang_misc['Posts'], ($forum_page['start_from'] + 1), ($cur_topic['num_replies'] + 1));
@@ -521,7 +521,6 @@
 
 		$forum_page['post_ident'] = array();
 		$forum_page['message'] = array();
-		$forum_page['author_title'] = '';
 		$forum_page['user_ident'] = array();
 		$cur_post['username'] = $cur_post['poster'];
 
@@ -755,7 +754,12 @@
 			message($lang_misc['No topics selected']);
 
 		if (count($topics) == 1)
+		{
 			$topics = $topics[0];
+			$action = 'single';
+		}
+		else
+			$action = 'multiple';
 	}
 	else
 	{
@@ -764,7 +768,9 @@
 			message($lang_common['Bad request']);
 
 		$action = 'single';
-
+	}
+	if ($action == 'single')
+	{
 		// Fetch the topic subject
 		$query = array(
 			'SELECT'	=> 't.subject',
@@ -815,7 +821,7 @@
 
 	$forum_page['hidden_fields'] = array(
 		'csrf_token'	=> '<input type="hidden" name="csrf_token" value="'.generate_form_token($forum_page['form_action']).'" />',
-		'topics'		=> '<input type="hidden" name="topics" value="'.$topics.'" />'
+		'topics'		=> '<input type="hidden" name="topics" value="'.($action == 'single' ? $topics : implode(',', $topics)).'" />'
 	);
 
 	// Setup breadcrumbs
@@ -921,7 +927,7 @@
 		message($lang_misc['No topics selected']);
 
 	if (count($topics) == 1)
-			message($lang_misc['Merge error']);
+		message($lang_misc['Merge error']);
 
 	if (isset($_POST['merge_topics_comply']))
 	{
@@ -1011,9 +1017,6 @@
 		$lang_misc['Merge topics']
 	);
 
-	// Setup main heading
-	$forum_page['main_title'] = end($forum_page['crumbs']);
-
 	($hook = get_hook('mr_merge_topics_pre_header_load')) ? eval($hook) : null;
 
 	define('FORUM_PAGE', 'dialogue');
@@ -1035,7 +1038,7 @@
 			</div>
 <?php ($hook = get_hook('mr_merge_topics_pre_fieldset')) ? eval($hook) : null; ?>
 			<fieldset class="frm-group group<?php echo ++$forum_page['group_count'] ?>">
-				<legend class="group-legend"><strong><?php echo $lang_misc['Merge topic'] ?></strong></legend>
+				<legend class="group-legend"><strong><?php echo $lang_misc['Merge topics'] ?></strong></legend>
 <?php ($hook = get_hook('mr_merge_topics_pre_redirect_checkbox')) ? eval($hook) : null; ?>
 				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
 					<div class="sf-box checkbox">
@@ -1420,7 +1423,7 @@
 // Determine the topic offset (based on $_GET['p'])
 $forum_page['num_pages'] = ceil($cur_forum['num_topics'] / $forum_user['disp_topics']);
 
-$forum_page['page'] = (!isset($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $forum_page['num_pages']) ? 1 : $_GET['p'];
+$forum_page['page'] = (!isset($_GET['p']) || !is_numeric($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $forum_page['num_pages']) ? 1 : $_GET['p'];
 $forum_page['start_from'] = $forum_user['disp_topics'] * ($forum_page['page'] - 1);
 $forum_page['finish_at'] = min(($forum_page['start_from'] + $forum_user['disp_topics']), ($cur_forum['num_topics']));
 $forum_page['items_info'] = generate_items_info($lang_misc['Topics'], ($forum_page['start_from'] + 1), $cur_forum['num_topics']);
@@ -1531,16 +1534,17 @@
 		++$forum_page['item_count'];
 
 		// Start from scratch
-		$forum_page['item_subject'] = $forum_page['item_body'] = $forum_page['item_status'] = $forum_page['item_nav'] = $forum_page['item_title'] = $forum_page['item_subject_status'] = array();
-		$forum_page['item_indicator'] = '';
+		$forum_page['item_subject'] = $forum_page['item_body'] = $forum_page['item_status'] = $forum_page['item_nav'] = $forum_page['item_title'] = $forum_page['item_title_status'] = array();
 
 		if ($forum_config['o_censoring'] == '1')
 			$cur_topic['subject'] = censor_words($cur_topic['subject']);
 
+		$forum_page['item_subject']['starter'] = '<span class="item-starter">'.sprintf($lang_forum['Topic starter'], forum_htmlencode($cur_topic['poster'])).'</span>';
+
 		if ($cur_topic['moved_to'] != null)
 		{
 			$forum_page['item_status']['moved'] = 'moved';
-			$forum_page['item_title']['link'] = '<a href="'.forum_link($forum_url['topic'], array($cur_topic['moved_to'], sef_friendly($cur_topic['subject']))).'"><span>'.$lang_forum['Moved'].'</span> '.forum_htmlencode($cur_topic['subject']).'</a>';
+			$forum_page['item_title']['link'] = '<span class="item-status"><em class="moved">'.sprintf($lang_forum['Item status'], $lang_forum['Moved']).'</em></span> <a href="'.forum_link($forum_url['topic'], array($cur_topic['moved_to'], sef_friendly($cur_topic['subject']))).'">'.forum_htmlencode($cur_topic['subject']).'</a>';
 
 			// Combine everything to produce the Topic heading
 			$forum_page['item_body']['subject']['title'] = '<h3 class="hn"><span class="item-num">'.forum_number_format($forum_page['start_from'] + $forum_page['item_count']).'</span> <strong>'.$forum_page['item_title']['link'].'</strong></h3>';
@@ -1552,7 +1556,7 @@
 
 			$forum_page['item_body']['info']['replies'] = '<li class="info-replies"><span class="label">'.$lang_forum['No replies info'].'</span></li>';
 			$forum_page['item_body']['info']['lastpost'] = '<li class="info-lastpost"><span class="label">'.$lang_forum['No lastpost info'].'</span></li>';
-			$forum_page['item_body']['info']['select'] = '<li class="info-select"><input id="fld'.++$forum_page['fld_count'].'" type="checkbox" name="topics[]" value="'.$cur_topic['id'].'" /> <label for="fld'.$forum_page['fld_count'].'">'.sprintf($lang_forum['Select topic'], $cur_topic['subject']).'</label></li>';
+			$forum_page['item_body']['info']['select'] = '<li class="info-select"><input id="fld'.++$forum_page['fld_count'].'" type="checkbox" name="topics[]" value="'.$cur_topic['id'].'" /> <label for="fld'.$forum_page['fld_count'].'">'.sprintf($lang_forum['Select topic'], forum_htmlencode($cur_topic['subject'])).'</label></li>';
 
 			($hook = get_hook('mr_topic_actions_moved_row_pre_output')) ? eval($hook) : null;
 		}
@@ -1569,8 +1573,33 @@
 				$forum_page['item_status']['posted'] = 'posted';
 			}
 
+			if ($cur_topic['sticky'] == '1')
+			{
+				$forum_page['item_title_status']['sticky'] = '<em class="sticky">'.$lang_forum['Sticky'].'</em>';
+				$forum_page['item_status']['sticky'] = 'sticky';
+			}
+
+			if ($cur_topic['closed'] == '1')
+			{
+				$forum_page['item_title_status']['closed'] = '<em class="closed">'.$lang_forum['Closed'].'</em>';
+				$forum_page['item_status']['closed'] = 'closed';
+			}
+
+			($hook = get_hook('mr_topic_loop_normal_topic_pre_item_title_status_merge')) ? eval($hook) : null;
+
+			if (!empty($forum_page['item_title_status']))
+				$forum_page['item_title']['status'] = '<span class="item-status">'.sprintf($lang_forum['Item status'], implode(', ', $forum_page['item_title_status'])).'</span>';
+
 			$forum_page['item_title']['link'] = '<strong><a href="'.forum_link($forum_url['topic'], array($cur_topic['id'], sef_friendly($cur_topic['subject']))).'">'.forum_htmlencode($cur_topic['subject']).'</a></strong>';
 
+			($hook = get_hook('mr_topic_loop_normal_topic_pre_item_title_merge')) ? eval($hook) : null;
+
+			$forum_page['item_body']['subject']['title'] = '<h3 class="hn"><span class="item-num">'.forum_number_format($forum_page['start_from'] + $forum_page['item_count']).'</span> '.implode(' ', $forum_page['item_title']).'</h3>';
+
+
+			if (empty($forum_page['item_status']))
+				$forum_page['item_status']['normal'] = 'normal';
+
 			$forum_page['item_pages'] = ceil(($cur_topic['num_replies'] + 1) / $forum_user['disp_posts']);
 
 			if ($forum_page['item_pages'] > 1)
@@ -1583,47 +1612,27 @@
 				$forum_page['item_status']['new'] = 'new';
 			}
 
-			if (!empty($forum_page['item_nav']))
-				$forum_page['item_title']['nav'] = '<span class="item-nav">'.sprintf($lang_forum['Topic navigation'], implode('&#160;&#160;', $forum_page['item_nav'])).'</span>';
-
-			($hook = get_hook('mr_topic_actions_moved_row_pre_item_title_merge')) ? eval($hook) : null;
+			($hook = get_hook('mr_topic_loop_normal_topic_pre_item_nav_merge')) ? eval($hook) : null;
 
-			$forum_page['item_body']['subject']['title'] = '<h3 class="hn"><span class="item-num">'.forum_number_format($forum_page['start_from'] + $forum_page['item_count']).'</span> '.implode(' ', $forum_page['item_title']).'</h3>';
+			if (!empty($forum_page['item_nav']))
+				$forum_page['item_subject']['nav'] = '<span class="item-nav">'.sprintf($lang_forum['Topic navigation'], implode('&#160;&#160;', $forum_page['item_nav'])).'</span>';
 
 			// Assemble the Topic subject
 
-			if ($cur_topic['sticky'] == '1')
-			{
-				$forum_page['item_subject_status']['sticky'] = $lang_forum['Sticky'];
-				$forum_page['item_status']['sticky'] = 'sticky';
-			}
-
-			if ($cur_topic['closed'] == '1')
-			{
-				$forum_page['item_subject_status']['closed'] = $lang_forum['Closed'];
-				$forum_page['item_status']['closed'] = 'closed';
-			}
-
-			($hook = get_hook('mr_topic_actions_moved_row_pre_item_subject_status_merge')) ? eval($hook) : null;
-
-			if (!empty($forum_page['item_subject_status']))
-				$forum_page['item_subject']['status'] = '<span class="item-status">'.sprintf($lang_forum['Item status'], implode(' ', $forum_page['item_subject_status'])).'</span>';
-
-			if (empty($forum_page['item_status']))
-				$forum_page['item_status']['normal'] = 'normal';
+			$forum_page['item_body']['info']['replies'] = '<li class="info-replies"><strong>'.forum_number_format($cur_topic['num_replies']).'</strong> <span class="label">'.(($cur_topic['num_replies'] == 1) ? $lang_forum['Reply'] : $lang_forum['Replies']).'</span></li>';
 
 			if ($forum_config['o_topic_views'] == '1')
 				$forum_page['item_body']['info']['views'] = '<li class="info-views"><strong>'.forum_number_format($cur_topic['num_views']).'</strong> <span class="label">'.(($cur_topic['num_views'] == 1) ? $lang_forum['View'] : $lang_forum['Views']).'</span></li>';
 
-			$forum_page['item_body']['info']['replies'] = '<li class="info-replies"><strong>'.forum_number_format($cur_topic['num_replies']).'</strong> <span class="label">'.(($cur_topic['num_replies'] == 1) ? $lang_forum['Reply'] : $lang_forum['Replies']).'</span></li>';
 			$forum_page['item_body']['info']['lastpost'] = '<li class="info-lastpost"><span class="label">'.$lang_forum['Last post'].'</span> <strong><a href="'.forum_link($forum_url['post'], $cur_topic['last_post_id']).'">'.format_time($cur_topic['last_post']).'</a></strong> <cite>'.sprintf($lang_forum['by poster'], forum_htmlencode($cur_topic['last_poster'])).'</cite></li>';
-			$forum_page['item_body']['info']['select'] = '<li class="info-select"><input id="fld'.++$forum_page['fld_count'].'" type="checkbox" name="topics[]" value="'.$cur_topic['id'].'" /> <label for="fld'.$forum_page['fld_count'].'">'.sprintf($lang_forum['Select topic'], $cur_topic['subject']).'</label></li>';
+			$forum_page['item_body']['info']['select'] = '<li class="info-select"><input id="fld'.++$forum_page['fld_count'].'" type="checkbox" name="topics[]" value="'.$cur_topic['id'].'" /> <label for="fld'.$forum_page['fld_count'].'">'.sprintf($lang_forum['Select topic'], forum_htmlencode($cur_topic['subject'])).'</label></li>';
 
 			($hook = get_hook('mr_topic_actions_normal_row_pre_output')) ? eval($hook) : null;
 		}
 
-		$forum_page['item_subject']['starter'] = '<span class="item-starter">'.sprintf($lang_forum['Topic starter'], '<cite>'.forum_htmlencode($cur_topic['poster']).'</cite>').'</span>';
-		$forum_page['item_body']['subject']['desc'] = implode(' ', $forum_page['item_subject']);
+		$forum_page['item_body']['subject']['desc'] = '<p>'.implode(' ', $forum_page['item_subject']).'</p>';
+
+		($hook = get_hook('mr_topic_actions_row_pre_item_status_merge')) ? eval($hook) : null;
 
 		$forum_page['item_style'] = (($forum_page['item_count'] % 2 != 0) ? ' odd' : ' even').(($forum_page['item_count'] == 1) ? ' main-first-item' : '').((!empty($forum_page['item_status'])) ? ' '.implode(' ', $forum_page['item_status']) : '');
 
